#include <iostream>
#include <string.h>
#include <math.h>
using namespace std;
//anavolimilovana

int main()
{
    string niska;
    cin>>niska;
    int v=niska.size();
    int a=0;

    int l=0;
    int d=0;

    for(int i = 0; i < v/2; i++)
    {
        l+=niska[i];
        d+=niska[v-i-1];
    }
    bool check=false;
    if (l!=d) check=true;

    char pom = niska[0];

    for(int i = 1; i < v; i++)
    {
        pom = pom ^ niska[i];
    }
    int br=0;

    if(niska[v/2]==pom && check==false)
    {
        for(int i=0;i<v/2;i++)
        {
            if(niska[i]!=niska[v-i-1]) br++;
        }
        if(br==0) br++;
        cout<<br;
    }
    else if(v%2==0 || niska[v/2]!=pom || (niska[v/2]==pom && check==true))
    {
        for(int i=0;i<v/2;i++)
        {
            if(niska[i]!=niska[v-i-1]) {br++; break;}
            br++;

        }
        br=v-2*br+1;
        cout<<br;

    }




}